#ifndef __ASSERT_H_
#define __ASSERT_H_

#include "types.h"

#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"

#ifndef DEBUG
#define STOP_IF_ERR( err, msg )
#define ASSERT_RULE( cond, msg )
#else
#define STOP_IF_ERR( err, msg ) if ( ( err ) == NRF_ERROR_INTERNAL ) for ( ; ; );
//#define ASSERT_RULE( cond, msg ) if ( !( cond ) ) for ( ; ; );
#define ASSERT_RULE( cond, msg ) if ( !( cond ) )                                \
                                  {                                               \
                                      NRF_LOG_INFO( __FILE__, __LINE__, msg );     \
                                      for ( ; ; );                                \
                                  }
#endif

#define EXIT_IF_ERR( err, msg ) if ( ( err ) == NRF_ERROR_INTERNAL ) goto _EXIT;
#define EXIT_IF_NOK( res )      if ( ( res ) != RESULT_OK ) goto _EXIT;

#endif /* __ASSERT_H_ */
