
#ifndef __STREAM_H_
#define __STREAM_H_

#include "types.h"
#include "buffer.h"

typedef struct stream stream_t;

typedef enum
{
    STREAM_TYPE_INPUT = 1,
    STREAM_TYPE_OUTPUT,
} stream_type_t;

typedef struct
{
    stream_type_t type;

    buffer_conf_t buffer;
} stream_conf_t;

extern ret_code_t stream_init( stream_t ** __stream, const stream_conf_t * _conf );

extern buffer_t * stream_get_buffer( stream_t * _stream );
extern buffer_t * stream_get_cache( stream_t * _stream );

extern void stream_cache_sync( stream_t * _stream );

#endif /* __STREAM_H_ */

